// Copyright (C) 2008 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include <string>

class MyCheckPoints
{
	public:

		typedef struct
		{
			int magic;
			unsigned int ncheckpoints;
		} Info;

		typedef struct
		{
			float *checkpoints;
		} Content;

		Info info;
		Content content;

		MyCheckPoints(void);

		virtual
		~MyCheckPoints(void);

		bool
		load(const std::string &filename, bool compiled = true);

		virtual
		void
		unload(void);

		bool
		save(const std::string &filename, bool compiled = true);
};

